
class Set {

	int[] store;
	int next;

	Set() {
		store = new int[8];
		next = 0;
	}

	int size() {
		return next;
	}

	void add(int value) {
		if (contains(value)) {
			return;
		}
		ensureCapacity();
		store[next] = value;
		next++;
	}

	boolean contains(int value) {
		for (int i = 0; i < next; i++) {
			if (store[i] == value) {
				return true;
			}
		}
		return false;
	}

	void insert(int index, int value) { // without index check
		if (contains(value)) {
			return;
		}
		ensureCapacity();
		for (int i = next; i > index; i--) {
			store[i] = store[i - 1];
		}
		store[index] = value;
		next++;
	}

	void prepend(int value) {
		insert(0, value);
	}

	int get(int index) {
		return store[index]; // without index check
	}

	void remove(int value) {
		for (int i = 0; i < next; i++) {
			if (store[i] == value) {
				for (int j = i; j < store.length - 1; j++) {
					store[j] = store[j + 1];
				}
				next--;
				i--;
			}
		}
	}

	int removeAtIndex(int index) { // without index check
		int result = store[index];
		for (int i = index; i < next - 1; i++) {
			store[i] = store[i + 1];
		}
		next--;
		return result;
	}

	void ensureCapacity() {
		if (next == store.length) {
			int[] buffer = new int[store.length * 2];
			for (int i = 0; i < store.length; i++) {
				buffer[i] = store[i];
			}
			store = buffer;
		}
	}

	// Testprogramm
	public static void main(String[] args) {
		Set list = new Set();
		for (int i = 0; i < 10; i++) {
			list.add(i);
			list.add(i);
		}
		list.remove(5);
		list.remove(9);
		list.remove(0);
		for (int i = 10; i < 20; i++) {
			list.add(i);
		}
		list.insert(1, 77);
		for (int i = 0; i < list.size(); i++) {
			System.out.println(list.get(i));
		}

	}

}
